10 KEY OFF: DIM MAX(4), MIN(4)
20 CLS
30 INPUT "Enter ADC (check your manual) "; ADC
40 IF ((ADC < 544) OR (ADC > 626)) THEN PRINT "544 <= ADC <= 626": GOTO 30
50 START = ADC + 2: CLS
60 SMOOTH = 30: REM number of readings to average
70 LOCATE 24, 30: PRINT "Press Esc to exit"
80 LOCATE 3, 31: PRINT "Volts      Max        Min"
90 FOR N = 0 TO 3: MAX(N) = -5: MIN(N) = 5: NEXT: REM Initialize
100 LOCATE 5, 1
110 FOR CHANNEL = 0 TO 3
120 OUT ADC, CHANNEL * 16: REM select channel
130 COUNT = 0: FOR S = 1 TO SMOOTH
140 X = INP(START): REM start a conversion
150 IF (INP(ADC) AND 2) = 0 THEN GOTO 150: REM check status bit
160 LOW = INP(ADC + 1)
170 HIGH = (INP(ADC + 2) XOR 128): REM read the answer
180 COUNT = COUNT + LOW + HIGH * 256
190 NEXT S
200 COUNT = COUNT / SMOOTH
210 VOLTS = (COUNT - 32768!) * 1.52588E-04: REM scale in volts
220 IF VOLTS > MAX(CHANNEL) THEN MAX(CHANNEL) = VOLTS
230 IF VOLTS < MIN(CHANNEL) THEN MIN(CHANNEL) = VOLTS
240 PRINT "Channel"; CHANNEL; " count = ";
250 PRINT USING "#####"; COUNT;
260 PRINT USING "    ##.####"; VOLTS; MAX(CHANNEL); MIN(CHANNEL)
270 NEXT CHANNEL
280 PRINT : PRINT "Digital input is ";
290 IF INP(ADC) AND 128 THEN PRINT "OFF" ELSE PRINT "ON "
300 IF INKEY$ = CHR$(27) THEN END
310 GOTO 100
